/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.YYLogger
 *  fire.log.beans.OpPetTraBean
 *  fire.log.enums.YYLoggerTuJingEnum
 *  fire.pb.common.SCommon
 *  fire.pb.course.CourseManager
 *  fire.pb.item.ItemBase
 *  fire.pb.item.Pack
 *  fire.pb.item.pet.PetAptItem
 *  fire.pb.main.ConfigManager
 *  fire.pb.talk.MessageMgr
 *  fire.pb.talk.STransChatMessageNotify2Client
 *  fire.pb.util.Misc
 *  mkdb.Procedure
 *  mkio.Protocol
 */
package fire.pb.pet;

import fire.log.YYLogger;
import fire.log.beans.OpPetTraBean;
import fire.log.enums.YYLoggerTuJingEnum;
import fire.pb.common.SCommon;
import fire.pb.course.CourseManager;
import fire.pb.item.ItemBase;
import fire.pb.item.Pack;
import fire.pb.item.pet.PetAptItem;
import fire.pb.main.ConfigManager;
import fire.pb.pet.Helper;
import fire.pb.pet.Module;
import fire.pb.pet.Pet;
import fire.pb.pet.PetColumn;
import fire.pb.pet.SPetAptitudeCultivate;
import fire.pb.pet.SRefreshPetInfo;
import fire.pb.talk.MessageMgr;
import fire.pb.talk.STransChatMessageNotify2Client;
import fire.pb.util.Misc;
import java.util.ArrayList;
import java.util.TreeMap;
import mkdb.Procedure;
import mkio.Protocol;

public class PPetAptitudeCultivate
extends Procedure {
    private final long roleId;
    private final int petKey;
    private final int aptId;
    private final int itemKey;

    public PPetAptitudeCultivate(long roleId, int petKey, int aptId, int itemKey) {
        this.roleId = roleId;
        this.petKey = petKey;
        this.aptId = aptId;
        this.itemKey = itemKey;
    }

    public boolean process() {
        if (Helper.isPetInBattle(this.roleId, this.petKey)) {
            return false;
        }
        PetColumn petCol = new PetColumn(this.roleId, 1, false);
        Pet pet = petCol.getPet(this.petKey);
        if (null == pet) {
            return false;
        }
        if (pet.isLocked() != -1L) {
            MessageMgr.psendMsgNotify((long)this.roleId, (int)Pet.PET_LOCK_ERROR_MSG, null);
            return true;
        }
        int countLimit = this.getCountLimit();
        if (pet.getPetInfo().getAptaddcount() >= countLimit) {
            return true;
        }
        Pack bag = new Pack(this.roleId, false);
        ItemBase bi = bag.getItem(this.itemKey);
        if (bi == null) {
            return false;
        }
        if (!(bi instanceof PetAptItem)) {
            return false;
        }
        int curValue = 0;
        int maxValue = 0;
        int addValue = 0;
        int finalValue = 0;
        switch (this.aptId) {
            case 1440: {
                curValue = pet.getPetInfo().getBornattackapt();
                maxValue = pet.getPetAttr().getAttackaptmax();
                break;
            }
            case 1450: {
                curValue = pet.getPetInfo().getBorndefendapt();
                maxValue = pet.getPetAttr().getDefendaptmax();
                break;
            }
            case 1470: {
                curValue = pet.getPetInfo().getBornmagicapt();
                maxValue = pet.getPetAttr().getMagicaptmax();
                break;
            }
            case 1460: {
                curValue = pet.getPetInfo().getBornphyforceapt();
                maxValue = pet.getPetAttr().getPhyforceaptmax();
                break;
            }
            case 1480: {
                curValue = pet.getPetInfo().getBornspeedapt();
                maxValue = pet.getPetAttr().getSpeedaptmax();
                break;
            }
            default: {
                return false;
            }
        }
        addValue = this.getAddAptValue(curValue, maxValue);
        finalValue = curValue + addValue;
        if (finalValue > maxValue) {
            finalValue = maxValue;
        }
        if (curValue >= finalValue) {
            return true;
        }
        switch (this.aptId) {
            case 1440: {
                pet.getPetInfo().setBornattackapt(finalValue);
                break;
            }
            case 1450: {
                pet.getPetInfo().setBorndefendapt(finalValue);
                break;
            }
            case 1470: {
                pet.getPetInfo().setBornmagicapt(finalValue);
                break;
            }
            case 1460: {
                pet.getPetInfo().setBornphyforceapt(finalValue);
                break;
            }
            case 1480: {
                pet.getPetInfo().setBornspeedapt(finalValue);
                break;
            }
            default: {
                return false;
            }
        }
        pet.getPetInfo().setAptaddcount(pet.getPetInfo().getAptaddcount() + 1);
        pet.updatePetScoreWhileChange();
        CourseManager.checkAchieveCourse((long)this.roleId, (int)31, (int)pet.getPetInfo().getPetscore());
        int itemNum = 1;
        int num = bag.removeItemWithKey(this.itemKey, itemNum, YYLoggerTuJingEnum.tujing_Value_peiyang, bi.getItemId(), "Pet aptitude cultivate cost");
        if (num != itemNum) {
            return false;
        }
        SRefreshPetInfo refresh = new SRefreshPetInfo(pet.getProtocolPet());
        PPetAptitudeCultivate.psendWhileCommit((long)this.roleId, (Protocol)refresh);
        PPetAptitudeCultivate.psendWhileCommit((long)this.roleId, (Protocol)new SPetAptitudeCultivate(this.petKey, this.aptId, finalValue));
        ArrayList<String> params = new ArrayList<String>();
        params.add(pet.getName());
        params.add(pet.getAptitudeStringByAttrType(this.aptId, false));
        params.add(Integer.valueOf(addValue).toString());
        STransChatMessageNotify2Client msg = MessageMgr.getMsgNotify((int)150074, (int)0, params);
        PPetAptitudeCultivate.psendWhileCommit((long)this.roleId, (Protocol)msg);
        if (Module.logger.isInfoEnabled()) {
            Module.logger.info((Object)("[PPetAptitudeCultivate] roleId:" + this.roleId + " itemKey:" + this.itemKey + " itemId:" + bi.getItemId() + " itemName:" + bi.getName() + " aptId:" + this.aptId + " curValue:" + curValue + " maxValue:" + maxValue + " addValue:" + addValue + " finalValue:" + finalValue + " petInfo:" + Helper.toString(pet.getPetInfo())));
        }
        this.writeYYLogger(bi);
        return true;
    }

    private void writeYYLogger(ItemBase bi) {
        if (bi == null) {
            return;
        }
        YYLogger.petTraLog((long)this.roleId, (OpPetTraBean)new OpPetTraBean(bi.getItemId(), 1, this.aptId));
    }

    int getAddAptValue(int curValue, int maxValue) {
        int v1 = (int)((double)(maxValue - curValue) * 0.04 + 0.5);
        int v2 = (int)((double)(maxValue - curValue) * 0.06 + 0.5);
        int r = Misc.getRandomBetween((int)v1, (int)v2);
        return r > 0 ? r : 1;
    }

    int getCountLimit() {
        SCommon conf;
        TreeMap confs = ConfigManager.getInstance().getConf(SCommon.class);
        if (confs != null && (conf = (SCommon)confs.get(120)) != null) {
            return Integer.parseInt(conf.getValue());
        }
        return 0;
    }
}

